Index: uspace/srv/net/net/net.c
===================================================================
--- uspace/srv/net/net/net.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/net/net.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -78,6 +78,4 @@
 DEVICE_MAP_IMPLEMENT(netifs, netif_t);
 
-static int startup(void);
-
 /** Add the configured setting to the configuration map.
  *
@@ -86,14 +84,14 @@
  * @param[in] value         The setting value.
  *
- * @return EOK on success.
- * @return ENOMEM if there is not enough memory left.
- *
- */
-int add_configuration(measured_strings_t *configuration, const char *name,
+ * @returns EOK on success.
+ * @returns ENOMEM if there is not enough memory left.
+ *
+ */
+int add_configuration(measured_strings_ref configuration, const char *name,
     const char *value)
 {
 	int rc;
 	
-	measured_string_t *setting =
+	measured_string_ref setting =
 	    measured_string_create_bulk(value, 0);
 	if (!setting)
@@ -112,5 +110,5 @@
 /** Generate new system-unique device identifier.
  *
- * @return		The system-unique devic identifier.
+ * @returns		The system-unique devic identifier.
  */
 static device_id_t generate_new_device_id(void)
@@ -119,5 +117,5 @@
 }
 
-static int parse_line(measured_strings_t *configuration, char *line)
+static int parse_line(measured_strings_ref configuration, char *line)
 {
 	int rc;
@@ -165,5 +163,5 @@
 	
 	/* Create a bulk measured string till the end */
-	measured_string_t *setting =
+	measured_string_ref setting =
 	    measured_string_create_bulk(value, 0);
 	if (!setting)
@@ -181,5 +179,5 @@
 
 static int read_configuration_file(const char *directory, const char *filename,
-    measured_strings_t *configuration)
+    measured_strings_ref configuration)
 {
 	printf("%s: Reading configuration file %s/%s\n", NAME, directory, filename);
@@ -237,6 +235,6 @@
  * @param[in,out] netif The network interface structure.
  *
- * @return EOK on success.
- * @return Other error codes as defined for the add_configuration() function.
+ * @returns EOK on success.
+ * @returns Other error codes as defined for the add_configuration() function.
  *
  */
@@ -248,6 +246,6 @@
 /** Read the networking subsystem global configuration.
  *
- * @return EOK on success.
- * @return Other error codes as defined for the add_configuration() function.
+ * @returns EOK on success.
+ * @returns Other error codes as defined for the add_configuration() function.
  *
  */
@@ -264,6 +262,6 @@
  *                              its own one.
  *
- * @return EOK on success.
- * @return ENOMEM if there is not enough memory left.
+ * @returns EOK on success.
+ * @returns ENOMEM if there is not enough memory left.
  *
  */
@@ -315,7 +313,7 @@
  *                              its own one.
  *
- * @return EOK on successful module termination.
- * @return Other error codes as defined for the net_initialize() function.
- * @return Other error codes as defined for the REGISTER_ME() macro function.
+ * @returns EOK on successful module termination.
+ * @returns Other error codes as defined for the net_initialize() function.
+ * @returns Other error codes as defined for the REGISTER_ME() macro function.
  *
  */
@@ -339,9 +337,4 @@
 		goto out;
 	
-	rc = startup();
-	if (rc != EOK)
-		goto out;
-	
-	task_retval(0);
 	async_manager();
 
@@ -360,9 +353,9 @@
  * @param[out] data          The found configuration settings data.
  *
- * @return EOK.
- *
- */
-static int net_get_conf(measured_strings_t *netif_conf,
-    measured_string_t *configuration, size_t count, char **data)
+ * @returns EOK.
+ *
+ */
+static int net_get_conf(measured_strings_ref netif_conf,
+    measured_string_ref configuration, size_t count, char **data)
 {
 	if (data)
@@ -371,5 +364,5 @@
 	size_t index;
 	for (index = 0; index < count; index++) {
-		measured_string_t *setting =
+		measured_string_ref setting =
 		    measured_strings_find(netif_conf, configuration[index].value, 0);
 		if (!setting)
@@ -389,5 +382,5 @@
 }
 
-int net_get_conf_req(int net_phone, measured_string_t **configuration,
+int net_get_conf_req(int net_phone, measured_string_ref *configuration,
     size_t count, char **data)
 {
@@ -399,5 +392,5 @@
 
 int net_get_device_conf_req(int net_phone, device_id_t device_id,
-    measured_string_t **configuration, size_t count, char **data)
+    measured_string_ref *configuration, size_t count, char **data)
 {
 	if ((!configuration) || (count == 0))
@@ -411,5 +404,5 @@
 }
 
-void net_free_settings(measured_string_t *settings, char *data)
+void net_free_settings(measured_string_ref settings, char *data)
 {
 }
@@ -422,11 +415,11 @@
  * @param[in] netif The network interface specific data.
  *
- * @return EOK on success.
- * @return EINVAL if there are some settings missing.
- * @return ENOENT if the internet protocol module is not known.
- * @return Other error codes as defined for the netif_probe_req() function.
- * @return Other error codes as defined for the nil_device_req() function.
- * @return Other error codes as defined for the needed internet layer
- *         registering function.
+ * @returns EOK on success.
+ * @returns EINVAL if there are some settings missing.
+ * @returns ENOENT if the internet protocol module is not known.
+ * @returns Other error codes as defined for the netif_probe_req() function.
+ * @returns Other error codes as defined for the nil_device_req() function.
+ * @returns Other error codes as defined for the needed internet layer
+ *          registering function.
  *
  */
@@ -436,5 +429,5 @@
 	
 	/* Mandatory netif */
-	measured_string_t *setting =
+	measured_string_ref setting =
 	    measured_strings_find(&netif->configuration, CONF_NETIF, 0);
 	
@@ -514,13 +507,13 @@
 /** Read the configuration and start all network interfaces.
  *
- * @return EOK on success.
- * @return EXDEV if there is no available system-unique device identifier.
- * @return EINVAL if any of the network interface names are not configured.
- * @return ENOMEM if there is not enough memory left.
- * @return Other error codes as defined for the read_configuration()
- *         function.
- * @return Other error codes as defined for the read_netif_configuration()
- *         function.
- * @return Other error codes as defined for the start_device() function.
+ * @returns EOK on success.
+ * @returns EXDEV if there is no available system-unique device identifier.
+ * @returns EINVAL if any of the network interface names are not configured.
+ * @returns ENOMEM if there is not enough memory left.
+ * @returns Other error codes as defined for the read_configuration()
+ *          function.
+ * @returns Other error codes as defined for the read_netif_configuration()
+ *          function.
+ * @returns Other error codes as defined for the start_device() function.
  *
  */
@@ -557,5 +550,5 @@
 		
 		/* Mandatory name */
-		measured_string_t *setting =
+		measured_string_ref setting =
 		    measured_strings_find(&netif->configuration, CONF_NAME, 0);
 		if (!setting) {
@@ -617,6 +610,6 @@
  *                          in the answer parameter.
  *
- * @return EOK on success.
- * @return ENOTSUP if the message is not known.
+ * @returns EOK on success.
+ * @returns ENOTSUP if the message is not known.
  *
  * @see net_interface.h
@@ -627,5 +620,5 @@
     int *answer_count)
 {
-	measured_string_t *strings;
+	measured_string_ref strings;
 	char *data;
 	int rc;
Index: uspace/srv/net/net/net.h
===================================================================
--- uspace/srv/net/net/net.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/net/net.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -103,10 +103,10 @@
 	
 	/** Serving network interface driver module index. */
-	module_t *driver;
+	module_ref driver;
 	
-	device_id_t id;	/**< System-unique network interface identifier. */
-	module_t *il;	/**< Serving internet layer module index. */
-	char *name;	/**< System-unique network interface name. */
-	module_t *nil;	/**< Serving link layer module index. */
+	device_id_t id;  /**< System-unique network interface identifier. */
+	module_ref il;   /**< Serving internet layer module index. */
+	char *name;      /**< System-unique network interface name. */
+	module_ref nil;  /**< Serving link layer module index. */
 } netif_t;
 
@@ -133,5 +133,5 @@
 } net_globals_t;
 
-extern int add_configuration(measured_strings_t *, const char *, const char *);
+extern int add_configuration(measured_strings_ref, const char *, const char *);
 extern int net_module_message(ipc_callid_t, ipc_call_t *, ipc_call_t *, int *);
 extern int net_initialize_build(async_client_conn_t);
Index: uspace/srv/net/netif/lo/lo.c
===================================================================
--- uspace/srv/net/netif/lo/lo.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/netif/lo/lo.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -70,5 +70,5 @@
 }
 
-int netif_get_addr_message(device_id_t device_id, measured_string_t *address)
+int netif_get_addr_message(device_id_t device_id, measured_string_ref address)
 {
 	if (!address)
@@ -81,5 +81,5 @@
 }
 
-int netif_get_device_stats(device_id_t device_id, device_stats_t *stats)
+int netif_get_device_stats(device_id_t device_id, device_stats_ref stats)
 {
 	netif_device_t *device;
@@ -93,5 +93,5 @@
 		return rc;
 
-	memcpy(stats, (device_stats_t *) device->specific,
+	memcpy(stats, (device_stats_ref) device->specific,
 	    sizeof(device_stats_t));
 
@@ -103,6 +103,6 @@
  * @param[in] device	The device structure.
  * @param[in] state	The new device state.
- * @return		The new state if changed.
- * @return		EOK otherwise.
+ * @returns		The new state if changed.
+ * @returns		EOK otherwise.
  */
 static int change_state_message(netif_device_t *device, device_state_t state)
@@ -124,7 +124,7 @@
  * @param[in] device_id	The new devce identifier.
  * @param[out] device	The device structure.
- * @return		EOK on success.
- * @return		EXDEV if one loopback network interface already exists.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EXDEV if one loopback network interface already exists.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 static int create(device_id_t device_id, netif_device_t **device)
@@ -145,5 +145,5 @@
 	}
 
-	null_device_stats((device_stats_t *) (*device)->specific);
+	null_device_stats((device_stats_ref) (*device)->specific);
 	(*device)->device_id = device_id;
 	(*device)->nil_phone = -1;
@@ -185,9 +185,9 @@
 }
 
-int netif_send_message(device_id_t device_id, packet_t *packet, services_t sender)
+int netif_send_message(device_id_t device_id, packet_t packet, services_t sender)
 {
 	netif_device_t *device;
 	size_t length;
-	packet_t *next;
+	packet_t next;
 	int phone;
 	int rc;
@@ -204,9 +204,9 @@
 	next = packet;
 	do {
-		((device_stats_t *) device->specific)->send_packets++;
-		((device_stats_t *) device->specific)->receive_packets++;
+		((device_stats_ref) device->specific)->send_packets++;
+		((device_stats_ref) device->specific)->receive_packets++;
 		length = packet_get_data_length(next);
-		((device_stats_t *) device->specific)->send_bytes += length;
-		((device_stats_t *) device->specific)->receive_bytes += length;
+		((device_stats_ref) device->specific)->send_bytes += length;
+		((device_stats_ref) device->specific)->receive_bytes += length;
 		next = pq_next(next);
 	} while(next);
Index: uspace/srv/net/nil/eth/eth.c
===================================================================
--- uspace/srv/net/nil/eth/eth.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/nil/eth/eth.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -156,4 +156,9 @@
 typedef enum eth_addr_type eth_addr_type_t;
 
+/** Type definition of the ethernet address type pointer.
+ * @see eth_addr_type
+ */
+typedef eth_addr_type_t *eth_addr_type_ref;
+
 /** Ethernet address type. */
 enum eth_addr_type {
@@ -173,5 +178,5 @@
 {
 	int index;
-	eth_proto_t *proto;
+	eth_proto_ref proto;
 
 	fibril_rwlock_read_lock(&eth_globals.protos_lock);
@@ -234,5 +239,5 @@
 static void eth_receiver(ipc_callid_t iid, ipc_call_t *icall)
 {
-	packet_t *packet;
+	packet_t packet;
 	int rc;
 
@@ -268,12 +273,12 @@
  * @param[in] service	The device driver service.
  * @param[in] mtu	The device maximum transmission unit.
- * @return		EOK on success.
- * @return		EEXIST if the device with the different service exists.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EEXIST if the device with the different service exists.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
  *			net_get_device_conf_req() function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			netif_bind_service() function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			netif_get_addr_req() function.
  */
@@ -281,5 +286,5 @@
     size_t mtu)
 {
-	eth_device_t *device;
+	eth_device_ref device;
 	int index;
 	measured_string_t names[2] = {
@@ -293,8 +298,8 @@
 		}
 	};
-	measured_string_t *configuration;
+	measured_string_ref configuration;
 	size_t count = sizeof(names) / sizeof(measured_string_t);
 	char *data;
-	eth_proto_t *proto;
+	eth_proto_ref proto;
 	int rc;
 
@@ -337,5 +342,5 @@
 	
 	/* Create a new device */
-	device = (eth_device_t *) malloc(sizeof(eth_device_t));
+	device = (eth_device_ref) malloc(sizeof(eth_device_t));
 	if (!device)
 		return ENOMEM;
@@ -422,19 +427,19 @@
  * @param[in] flags	The device flags.
  * @param[in] packet	The packet.
- * @return		The target registered module.
- * @return		NULL if the packet is not long enough.
- * @return		NULL if the packet is too long.
- * @return		NULL if the raw ethernet protocol is used.
- * @return		NULL if the dummy device FCS checksum is invalid.
- * @return		NULL if the packet address length is not big enough.
- */
-static eth_proto_t *eth_process_packet(int flags, packet_t *packet)
-{
-	eth_header_snap_t *header;
+ * @returns		The target registered module.
+ * @returns		NULL if the packet is not long enough.
+ * @returns		NULL if the packet is too long.
+ * @returns		NULL if the raw ethernet protocol is used.
+ * @returns		NULL if the dummy device FCS checksum is invalid.
+ * @returns		NULL if the packet address length is not big enough.
+ */
+static eth_proto_ref eth_process_packet(int flags, packet_t packet)
+{
+	eth_header_snap_ref header;
 	size_t length;
 	eth_type_t type;
 	size_t prefix;
 	size_t suffix;
-	eth_fcs_t *fcs;
+	eth_fcs_ref fcs;
 	uint8_t *data;
 	int rc;
@@ -449,5 +454,5 @@
 	
 	data = packet_get_data(packet);
-	header = (eth_header_snap_t *) data;
+	header = (eth_header_snap_ref) data;
 	type = ntohs(header->header.ethertype);
 	
@@ -456,5 +461,5 @@
 		prefix = sizeof(eth_header_t);
 		suffix = 0;
-		fcs = (eth_fcs_t *) data + length - sizeof(eth_fcs_t);
+		fcs = (eth_fcs_ref) data + length - sizeof(eth_fcs_t);
 		length -= sizeof(eth_fcs_t);
 	} else if(type <= ETH_MAX_CONTENT) {
@@ -482,5 +487,5 @@
 
 		suffix = (type < ETH_MIN_CONTENT) ? ETH_MIN_CONTENT - type : 0U;
-		fcs = (eth_fcs_t *) data + prefix + type + suffix;
+		fcs = (eth_fcs_ref) data + prefix + type + suffix;
 		suffix += length - prefix - type;
 		length = prefix + type + suffix;
@@ -509,9 +514,9 @@
 
 int nil_received_msg_local(int nil_phone, device_id_t device_id,
-    packet_t *packet, services_t target)
-{
-	eth_proto_t *proto;
-	packet_t *next;
-	eth_device_t *device;
+    packet_t packet, services_t target)
+{
+	eth_proto_ref proto;
+	packet_t next;
+	eth_device_ref device;
 	int flags;
 
@@ -552,12 +557,12 @@
  * @param[out] content	The maximum content size.
  * @param[out] suffix	The minimum reserved suffix size.
- * @return		EOK on success.
- * @return		EBADMEM if either one of the parameters is NULL.
- * @return		ENOENT if there is no such device.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if either one of the parameters is NULL.
+ * @returns		ENOENT if there is no such device.
  */
 static int eth_packet_space_message(device_id_t device_id, size_t *addr_len,
     size_t *prefix, size_t *content, size_t *suffix)
 {
-	eth_device_t *device;
+	eth_device_ref device;
 
 	if (!addr_len || !prefix || !content || !suffix)
@@ -586,12 +591,12 @@
  * @param[in] type	Type of the desired address.
  * @param[out] address	The device hardware address.
- * @return		EOK on success.
- * @return		EBADMEM if the address parameter is NULL.
- * @return		ENOENT if there no such device.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the address parameter is NULL.
+ * @returns		ENOENT if there no such device.
  */
 static int eth_addr_message(device_id_t device_id, eth_addr_type_t type,
-    measured_string_t **address)
-{
-	eth_device_t *device;
+    measured_string_ref *address)
+{
+	eth_device_ref device;
 
 	if (!address)
@@ -620,11 +625,11 @@
  * @param[in] service	The module service.
  * @param[in] phone	The service phone.
- * @return		EOK on success.
- * @return		ENOENT if the service is not known.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		ENOENT if the service is not known.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 static int eth_register_message(services_t service, int phone)
 {
-	eth_proto_t *proto;
+	eth_proto_ref proto;
 	int protocol;
 	int index;
@@ -641,5 +646,5 @@
 		return EOK;
 	} else {
-		proto = (eth_proto_t *) malloc(sizeof(eth_proto_t));
+		proto = (eth_proto_ref) malloc(sizeof(eth_proto_t));
 		if (!proto) {
 			fibril_rwlock_write_unlock(&eth_globals.protos_lock);
@@ -673,18 +678,18 @@
  * @param[in] ethertype	The ethernet protocol type.
  * @param[in] mtu	The device maximum transmission unit.
- * @return		EOK on success.
- * @return		EINVAL if the packet addresses length is not long
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet addresses length is not long
  *			enough.
- * @return		EINVAL if the packet is bigger than the device MTU.
- * @return		ENOMEM if there is not enough memory in the packet.
+ * @returns		EINVAL if the packet is bigger than the device MTU.
+ * @returns		ENOMEM if there is not enough memory in the packet.
  */
 static int
-eth_prepare_packet(int flags, packet_t *packet, uint8_t *src_addr, int ethertype,
+eth_prepare_packet(int flags, packet_t packet, uint8_t *src_addr, int ethertype,
     size_t mtu)
 {
-	eth_header_snap_t *header;
-	eth_header_lsap_t *header_lsap;
-	eth_header_t *header_dix;
-	eth_fcs_t *fcs;
+	eth_header_snap_ref header;
+	eth_header_lsap_ref header_lsap;
+	eth_header_ref header_dix;
+	eth_fcs_ref fcs;
 	uint8_t *src;
 	uint8_t *dest;
@@ -692,5 +697,5 @@
 	int i;
 	void *padding;
-	eth_preamble_t *preamble;
+	eth_preamble_ref preamble;
 
 	i = packet_get_addr(packet, &src, &dest);
@@ -783,14 +788,14 @@
  * @param[in] packet	The packet queue.
  * @param[in] sender	The sending module service.
- * @return		EOK on success.
- * @return		ENOENT if there no such device.
- * @return		EINVAL if the service parameter is not known.
- */
-static int eth_send_message(device_id_t device_id, packet_t *packet,
+ * @returns		EOK on success.
+ * @returns		ENOENT if there no such device.
+ * @returns		EINVAL if the service parameter is not known.
+ */
+static int eth_send_message(device_id_t device_id, packet_t packet,
     services_t sender)
 {
-	eth_device_t *device;
-	packet_t *next;
-	packet_t *tmp;
+	eth_device_ref device;
+	packet_t next;
+	packet_t tmp;
 	int ethertype;
 	int rc;
@@ -840,6 +845,6 @@
     ipc_call_t *call, ipc_call_t *answer, int *answer_count)
 {
-	measured_string_t *address;
-	packet_t *packet;
+	measured_string_ref address;
+	packet_t packet;
 	size_t addrlen;
 	size_t prefix;
Index: uspace/srv/net/nil/eth/eth.h
===================================================================
--- uspace/srv/net/nil/eth/eth.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/nil/eth/eth.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -54,8 +54,18 @@
 typedef struct eth_device eth_device_t;
 
+/** Type definition of the Ethernet device specific data pointer.
+ * @see eth_device
+ */
+typedef eth_device_t *eth_device_ref;
+
 /** Type definition of the Ethernet protocol specific data.
  * @see eth_proto
  */
 typedef struct eth_proto eth_proto_t;
+
+/** Type definition of the Ethernet protocol specific data pointer.
+ * @see eth_proto
+ */
+typedef eth_proto_t *eth_proto_ref;
 
 /** Ethernet device map.
@@ -90,5 +100,5 @@
 	
 	/** Actual device hardware address. */
-	measured_string_t *addr;
+	measured_string_ref addr;
 	/** Actual device hardware address data. */
 	char *addr_data;
@@ -123,5 +133,5 @@
 	
 	/** Broadcast device hardware address. */
-	measured_string_t *broadcast_addr;
+	measured_string_ref broadcast_addr;
 };
 
Index: uspace/srv/net/nil/eth/eth_header.h
===================================================================
--- uspace/srv/net/nil/eth/eth_header.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/nil/eth/eth_header.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -58,4 +58,11 @@
 typedef struct eth_header_snap eth_header_snap_t;
 
+/** Type definition of the Ethernet header IEEE 802.3 + 802.2 + SNAP extensions
+ * pointer.
+ *
+ * @see eth_header_snap
+ */
+typedef eth_header_snap_t *eth_header_snap_ref;
+
 /** Type definition of the Ethernet header IEEE 802.3 + 802.2 + SNAP extensions.
  * @see eth_header_lsap
@@ -63,4 +70,9 @@
 typedef struct eth_header_lsap eth_header_lsap_t;
 
+/** Type definition of the Ethernet header IEEE 802.3 + 802.2 extension pointer.
+ * @see eth_header_lsap
+ */
+typedef eth_header_lsap_t *eth_header_lsap_ref;
+
 /** Type definition of the Ethernet header LSAP extension.
  * @see eth_ieee_lsap
@@ -68,4 +80,9 @@
 typedef struct eth_ieee_lsap eth_ieee_lsap_t;
 
+/** Type definition of the Ethernet header LSAP extension pointer.
+ * @see eth_ieee_lsap
+ */
+typedef eth_ieee_lsap_t *eth_ieee_lsap_ref;
+
 /** Type definition of the Ethernet header SNAP extension.
  * @see eth_snap
@@ -73,4 +90,9 @@
 typedef struct eth_snap eth_snap_t;
 
+/** Type definition of the Ethernet header SNAP extension pointer.
+ * @see eth_snap
+ */
+typedef eth_snap_t *eth_snap_ref;
+
 /** Type definition of the Ethernet header preamble.
  * @see preamble
@@ -78,8 +100,18 @@
 typedef struct eth_preamble eth_preamble_t;
 
+/** Type definition of the Ethernet header preamble pointer.
+ * @see eth_preamble
+ */
+typedef eth_preamble_t *eth_preamble_ref;
+
 /** Type definition of the Ethernet header.
  * @see eth_header
  */
 typedef struct eth_header eth_header_t;
+
+/** Type definition of the Ethernet header pointer.
+ * @see eth_header
+ */
+typedef eth_header_t *eth_header_ref;
 
 /** Ethernet header Link Service Access Point extension. */
@@ -187,4 +219,7 @@
 typedef uint32_t eth_fcs_t;
 
+/** Ethernet Frame Check Sequence pointer. */
+typedef eth_fcs_t *eth_fcs_ref;
+
 #endif
 
Index: uspace/srv/net/nil/nildummy/nildummy.c
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/nil/nildummy/nildummy.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -106,5 +106,5 @@
 static void nildummy_receiver(ipc_callid_t iid, ipc_call_t *icall)
 {
-	packet_t *packet;
+	packet_t packet;
 	int rc;
 
@@ -142,10 +142,10 @@
  * @param[in] service	The device driver service.
  * @param[in] mtu	The device maximum transmission unit.
- * @return		EOK on success.
- * @return		EEXIST if the device with the different service exists.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EEXIST if the device with the different service exists.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
  *			netif_bind_service() function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			netif_get_addr_req() function.
  */
@@ -153,5 +153,5 @@
     size_t mtu)
 {
-	nildummy_device_t *device;
+	nildummy_device_ref device;
 	int index;
 	int rc;
@@ -192,5 +192,5 @@
 	
 	/* Create a new device */
-	device = (nildummy_device_t *) malloc(sizeof(nildummy_device_t));
+	device = (nildummy_device_ref) malloc(sizeof(nildummy_device_t));
 	if (!device)
 		return ENOMEM;
@@ -248,7 +248,7 @@
  */
 static int nildummy_addr_message(device_id_t device_id,
-    measured_string_t **address)
-{
-	nildummy_device_t *device;
+    measured_string_ref *address)
+{
+	nildummy_device_ref device;
 
 	if (!address)
@@ -282,5 +282,5 @@
     size_t *prefix, size_t *content, size_t *suffix)
 {
-	nildummy_device_t *device;
+	nildummy_device_ref device;
 
 	if (!addr_len || !prefix || !content || !suffix)
@@ -304,7 +304,7 @@
 
 int nil_received_msg_local(int nil_phone, device_id_t device_id,
-    packet_t *packet, services_t target)
-{
-	packet_t *next;
+    packet_t packet, services_t target)
+{
+	packet_t next;
 
 	fibril_rwlock_read_lock(&nildummy_globals.protos_lock);
@@ -354,8 +354,8 @@
  * @return		EINVAL if the service parameter is not known.
  */
-static int nildummy_send_message(device_id_t device_id, packet_t *packet,
+static int nildummy_send_message(device_id_t device_id, packet_t packet,
     services_t sender)
 {
-	nildummy_device_t *device;
+	nildummy_device_ref device;
 
 	fibril_rwlock_read_lock(&nildummy_globals.devices_lock);
@@ -377,6 +377,6 @@
     ipc_call_t *call, ipc_call_t *answer, int *answer_count)
 {
-	measured_string_t *address;
-	packet_t *packet;
+	measured_string_ref address;
+	packet_t packet;
 	size_t addrlen;
 	size_t prefix;
Index: uspace/srv/net/nil/nildummy/nildummy.h
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/nil/nildummy/nildummy.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -54,8 +54,18 @@
 typedef struct nildummy_device nildummy_device_t;
 
+/** Type definition of the dummy nil device specific data pointer.
+ * @see nildummy_device
+ */
+typedef nildummy_device_t *nildummy_device_ref;
+
 /** Type definition of the dummy nil protocol specific data.
  * @see nildummy_proto
  */
 typedef struct nildummy_proto nildummy_proto_t;
+
+/** Type definition of the dummy nil protocol specific data pointer.
+ * @see nildummy_proto
+ */
+typedef nildummy_proto_t *nildummy_proto_ref;
 
 /** Dummy nil device map.
@@ -76,5 +86,5 @@
 	size_t mtu;
 	/** Actual device hardware address. */
-	measured_string_t *addr;
+	measured_string_ref addr;
 	/** Actual device hardware address data. */
 	char *addr_data;
